package imcacat.imcabc;

import imcacat.epicsca4j.bean.OneWayPropertyChangeMediator;
import imcacat.epicsca4j.ca.EpicsCaException;
import imcacat.epicsca4j.model.EpicsPv;

/**
 * I am a model for details about an {@link AllAutoOptimization17bm}. I
 * provide the positions of the motors optimized by an
 * <code>AllAutoOptimization17bm</code>.
 */
public class AllAutoOptimizationDetails17bm extends
    BeamFocusAutoOptimizationDetails17bm {
  private static final long serialVersionUID = 1;

  public static final String PROPNAME_OMEGA_MOTOR_POSITION =
    "omegaMotorPosition";

  protected EpicsPv omegaMotorPositionPv;
  protected OneWayPropertyChangeMediator omegaMotorPositionMediator;

  public AllAutoOptimizationDetails17bm()
  throws InterruptedException, EpicsCaException {
    super();

    omegaMotorPositionPv = new EpicsPv(
      Resources.getDefault().getOmegaPositionPvName(), false, true);
    omegaMotorPositionMediator = new OneWayPropertyChangeMediator(
      omegaMotorPositionPv, this, EpicsPv.PROPNAME_VALUE,
      PROPNAME_OMEGA_MOTOR_POSITION);
  }

  @Override
  public void release() {
    omegaMotorPositionMediator.release();
    omegaMotorPositionPv.release();
    super.release();
  }

  public double getOmegaMotorPosition()
  throws InterruptedException, EpicsCaException {
    return (Double)omegaMotorPositionPv.getValue();
  }
}
