package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;

import java.awt.Frame;
import java.text.DecimalFormat;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;

import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

/**
 * I am a view for displaying the positions of the motors that are optimized
 * during an {@link AllAutoOptimization17bm}.
 */
public class AllAutoOptimizationDetailsDialog17bm
extends AutoOptimizationDetailsDialog {
  private static final long serialVersionUID = 1;

  public AllAutoOptimizationDetailsDialog17bm(Frame owner, String title,
      boolean modal)
  throws InterruptedException, EpicsCaException {
    this(owner, title, modal,
      new AllAutoOptimizationDetailsPresentationModel17bm());
  }

  public AllAutoOptimizationDetailsDialog17bm(Frame owner, String title,
      boolean modal,
      AllAutoOptimizationDetailsPresentationModel17bm model) {
    super(owner, title, modal, model);
  }

  @Override
  protected JComponent buildMainPanel() {
    FormLayout layout = new FormLayout(
      "right:pref, 4dlu, right:max(40dlu;pref)",
      "pref, 2dlu, pref, 2dlu, pref, 8dlu, pref"
    );
    layout.setRowGroups(new int[][] {{1, 3}});
    PanelBuilder builder = new PanelBuilder(layout);
    builder.border(Borders.DIALOG);
    CellConstraints cc = new CellConstraints();

    builder.addLabel("Omega (\u00B5rad):", cc.xy(1, 1));
    JLabel omegaValueLabel = ComponentFactory.createLabel(
      model.getModel(
        AllAutoOptimizationDetails17bm.PROPNAME_OMEGA_MOTOR_POSITION),
      new DecimalFormat("0.0"));
    builder.add(omegaValueLabel, cc.xy(3, 1));

    builder.addLabel("Horizontal beam focus (\u03BCm):", cc.xy(1, 3));
    JLabel horizontalBeamFocusValueLabel = ComponentFactory.createLabel(
      model.getModel(
        AllAutoOptimizationDetails17bm.PROPNAME_FOCUS_MOTOR_POSITION),
      new DecimalFormat("0.000"));
    builder.add(horizontalBeamFocusValueLabel, cc.xy(3, 3));

    builder.addLabel("Vertical beam focus (\u03BCm):", cc.xy(1, 5));
    JLabel verticalBeamFocusValueLabel = ComponentFactory.createLabel(
      model.getModel(
        AllAutoOptimizationDetails17bm.PROPNAME_MIRROR_BEND_MOTOR_POSITION),
      new DecimalFormat("0.0"));
    builder.add(verticalBeamFocusValueLabel, cc.xy(3, 5));

    builder.add(new JButton(doneAction), cc.xy(3, 7, "fill, default"));

    return builder.getPanel();
  }
}
