package imcacat.imcabc;

import java.util.ArrayList;
import java.util.List;

/**
 * I model anomalous scattering factors for a fluorescence scan.
 */
public class AnomalousScatteringFactors {
  protected MadEdge edge;
  protected List<Double> energies = new ArrayList<Double>();
  protected List<Double> fPrimes = new ArrayList<Double>();
  protected List<Double> fDoublePrimes = new ArrayList<Double>();

  public AnomalousScatteringFactors(List<Double> energies,
      List<Double> fPrimes, List<Double> fDoublePrimes) {
    this(null, energies, fPrimes, fDoublePrimes);
  }

  public AnomalousScatteringFactors(MadEdge edge, List<Double> energies,
      List<Double> fPrimes, List<Double> fDoublePrimes) {
    super();
    this.edge = edge;
    this.energies = energies;
    this.fPrimes = fPrimes;
    this.fDoublePrimes = fDoublePrimes;
  }

  public List<Double> getEnergies() {
    return energies;
  }

  public void setEnergies(List<Double> energy) {
    this.energies = energy;
  }

  public List<Double> getFPrimes() {
    return fPrimes;
  }

  public void setFPrimes(List<Double> fPrime) {
    this.fPrimes = fPrime;
  }

  public List<Double> getFDoublePrimes() {
    return fDoublePrimes;
  }

  public void setFDoublePrimes(List<Double> fDoublePrime) {
    this.fDoublePrimes = fDoublePrime;
  }

  public MadEdge getEdge() {
    return edge;
  }

  public void setEdge(MadEdge edge) {
    this.edge = edge;
  }
}
