package imcacat.imcabc;

import com.jgoodies.binding.PresentationModel;
import com.jgoodies.binding.value.ValueHolder;
import com.jgoodies.binding.value.ValueModel;

/**
 * I am the presentation model for {@link BeamPanel}.
 */
public abstract class BeamPresentationModel
<M extends BeamFacade,
  F extends FilterRackPresentationModel<? extends FilterRack>>
extends PresentationModel<M> {
  private static final long serialVersionUID = 1;

  protected F filterRackPresentationModel;

  public BeamPresentationModel(M bean) {
    this(new ValueHolder(bean, true));
  }

  public BeamPresentationModel(ValueModel beanChannel) {
    super(beanChannel);
    filterRackPresentationModel = createFilterRackPresentationModel();
  }

  protected abstract F createFilterRackPresentationModel();

  public F getFilterRackPresentationModel() {
    return filterRackPresentationModel;
  }
}
