package imcacat.imcabc;

/**
 * I represent a beamline.
 */
public enum Beamline {
  BM17 ("17bm", "17-BM"),
  ID17 ("17id", "17-ID");

  protected String id;
  protected String displayName;

  Beamline(String id, String displayName) {
    this.id = id;
    this.displayName = displayName;
  }

  public String getId() {
    return id;
  }

  public String getDisplayName() {
    return displayName;
  }

  public static Beamline getInstanceWithId(String id) {
    for (Beamline each : values()) if (each.getId().equals(id)) return each;
    return null;
  }

  public static Beamline getInstanceWithDisplayName(String displayName) {
    for (Beamline each : values())
      if (each.getDisplayName().equals(displayName)) return each;
    return null;
  }
}
