package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;

import java.awt.Frame;
import java.text.DecimalFormat;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;

import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

/**
 * I am a view for displaying the positions of the motors that are optimized
 * during a {@link BpmAutoOptimization17bm}.
 */
public class BpmAutoOptimizationDetailsDialog17bm
extends AutoOptimizationDetailsDialog {
  private static final long serialVersionUID = 1;

  public BpmAutoOptimizationDetailsDialog17bm(Frame owner, String title,
      boolean modal)
  throws InterruptedException, EpicsCaException {
    this(owner, title, modal,
      new BpmAutoOptimizationDetailsPresentationModel17bm());
  }

  public BpmAutoOptimizationDetailsDialog17bm(Frame owner, String title,
      boolean modal,
      BpmAutoOptimizationDetailsPresentationModel17bm model) {
    super(owner, title, modal, model);
  }

  @Override
  protected JComponent buildMainPanel() {
    FormLayout layout = new FormLayout(
      "right:pref, 4dlu, right:max(40dlu;pref)",
      "pref, 2dlu, pref, 8dlu, pref"
    );
    layout.setRowGroups(new int[][] {{1, 3}});
    PanelBuilder builder = new PanelBuilder(layout);
    builder.border(Borders.DIALOG);
    CellConstraints cc = new CellConstraints();

    builder.addLabel("BPM horizontal (\u03BCm):", cc.xy(1, 1));
    JLabel bpmHorizontalValueLabel = ComponentFactory.createLabel(
      model.getModel(
        BpmAutoOptimizationDetails17bm.
          PROPNAME_BPM_HORIZONTAL_MOTOR_POSITION), new DecimalFormat("0.0"));
    builder.add(bpmHorizontalValueLabel, cc.xy(3, 1));

    builder.addLabel("BPM vertical (\u03BCm):", cc.xy(1, 3));
    JLabel bpmVerticalValueLabel = ComponentFactory.createLabel(
      model.getModel(
        BpmAutoOptimizationDetails17bm.PROPNAME_BPM_VERTICAL_MOTOR_POSITION),
      new DecimalFormat("0.0"));
    builder.add(bpmVerticalValueLabel, cc.xy(3, 3));

    builder.add(new JButton(doneAction), cc.xy(3, 5, "fill, default"));

    return builder.getPanel();
  }
}
