package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;
import imcacat.epicsca4j.util.UiUtilities;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JPanel;

import org.jfree.chart.ChartPanel;

/**
 * I am a view of a {@link Bpm} displaying an XY grid showing the beam
 * position reported by the <code>Bpm</code>.
 */
public class BpmChartPanel extends JPanel {
  private static final long serialVersionUID = 1;

  protected static final Dimension PREFERRED_SIZE = new Dimension(300, 400);

  protected BpmChartPresentationModel model;

  public BpmChartPanel()
  throws InterruptedException, EpicsCaException {
    this(new BpmChartPresentationModel());
  }

  public BpmChartPanel(BpmChartPresentationModel model) {
    super();
    this.model = model;
    setLayout(new BorderLayout());
    add(buildMainPanel(), BorderLayout.CENTER);
    setPreferredSize(UiUtilities.createScaledDownToFitIn(getPreferredSize(),
      PREFERRED_SIZE));
  }

  protected JPanel buildMainPanel() {
    ChartPanel panel = new ChartPanel(model.getChart());
    panel.setDomainZoomable(false);
    panel.setRangeZoomable(false);
    panel.setPopupMenu(null);
    return panel;
  }
}
