package imcacat.imcabc;

/**
 * I am the result of the {@link ChoochWorker} computation.
 */
public class ChoochWorkerResult {
  protected String command;
  protected Exception doInBackgroundException;
  protected int exitValue;
  protected AnomalousScatteringFactors factors;

  protected ChoochWorkerResult(String command) {
    super();
    this.command = command;
  }

  public ChoochWorkerResult(String command, int exitValue) {
    this(command);
    this.exitValue = exitValue;
  }

  public ChoochWorkerResult(String command,
      AnomalousScatteringFactors factors) {
    this(command, 0);
    this.factors = factors;
  }

  public ChoochWorkerResult(String command,
      Exception doInBackgroundException) {
    this(command);
    this.doInBackgroundException = doInBackgroundException;
  }

  public String getCommand() {
    return command;
  }

  public Exception getDoInBackgroundException() {
    return doInBackgroundException;
  }

  public int getExitValue() {
    return exitValue;
  }

  public AnomalousScatteringFactors getAnomalousScatteringFactors() {
    return factors;
  }

  public boolean wasSuccessful() {
    return doInBackgroundException == null && exitValue == 0;
  }

  public boolean hadNonZeroExitValue() {
    return doInBackgroundException == null && exitValue != 0;
  }

  public boolean hadException() {
    return doInBackgroundException != null;
  }
}
