package imcacat.imcabc;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JFileChooser;

import com.jgoodies.binding.value.ValueModel;

/**
 * I open a directory chooser dialog, and I set the value of my
 * <code>ValueModel</code> to the chosen directory.
 */
public class ChooseDirectoryAction extends AbstractAction {
  private static final long serialVersionUID = 1;

  protected Component parent;
  protected String dialogTitle;
  protected String approveButtonText;
  protected ValueModel model;

  public ChooseDirectoryAction(Component parent, String name,
      String dialogTitle, ValueModel model) {
    this(parent, name, dialogTitle, "Select", model);
  }

  public ChooseDirectoryAction(Component parent, String name,
      String dialogTitle, String approveButtonText, ValueModel model) {
    super();

    this.parent = parent;
    this.dialogTitle = dialogTitle;
    this.approveButtonText = approveButtonText;
    this.model = model;
    putValue(Action.NAME, name);
  }

  public void actionPerformed(ActionEvent e) {
    JFileChooser chooser = new JFileChooser();
    chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    chooser.setDialogTitle(dialogTitle);
    chooser.setCurrentDirectory((File)model.getValue());
    int returnState = chooser.showDialog(parent, approveButtonText);
    if (returnState == JFileChooser.APPROVE_OPTION)
      model.setValue(chooser.getSelectedFile());
  }
}
