package imcacat.imcabc;

import imcacat.epicsca4j.convert.ConverterFactory;
import imcacat.imcabc.util.Pair;

import java.awt.Color;
import java.util.Map;

import javax.swing.JLabel;
import javax.swing.JProgressBar;

import com.jgoodies.binding.adapter.BasicComponentFactory;
import com.jgoodies.binding.adapter.Bindings;
import com.jgoodies.binding.beans.PropertyConnector;
import com.jgoodies.binding.value.ValueModel;

/**
 * I am a Java Swing component Factory.
 */
public class ComponentFactory extends BasicComponentFactory {
  //XXX senders that last longer than the model will not work here since this
  //    creates a connector and no reference to that connector is returned.
  //    I don't like this...refactor to be like createProgressBar or better
  public static JLabel createBooleanLabel(ValueModel model, String trueString,
      String falseString, Color trueColor, Color falseColor) {
    JLabel label = new JLabel();
    Bindings.bind(label,
      ConverterFactory.createBooleanToStringConverter(model, trueString,
        falseString));

    ValueModel labelColorModel =
      ConverterFactory.createBooleanToColorConverter(model, trueColor,
        falseColor);
    PropertyConnector.connectAndUpdate(labelColorModel, label, "foreground");

    return label;
  }

  //XXX not sure if this has the same problem of a sender lasting longer than
  //    the model...need to look into how Bindings work
  public static JLabel createEnumLabel(ValueModel model,
      Map<? extends Enum<?>,String>enumToStringMap) {
    JLabel label = new JLabel();
    Bindings.bind(label,
      ConverterFactory.createEnumToStringConverter(model, enumToStringMap));
    return label;
  }

  public static Pair<JProgressBar,ProgressBarMediator> createProgressBar(
      ValueModel progressModel) {
    return createProgressBar(progressModel, null);
  }

  public static Pair<JProgressBar,ProgressBarMediator> createProgressBar(
      ValueModel progressModel, ValueModel progressStringModel) {
    JProgressBar progressBar = new JProgressBar();
    progressBar.setStringPainted(true);
    ProgressBarMediator mediator = new ProgressBarMediator(progressBar,
      progressModel, progressStringModel);
    return new Pair<JProgressBar,ProgressBarMediator>(progressBar,mediator);
  }
}
