package imcacat.imcabc;

import java.awt.Color;
import java.util.Map;

import com.jgoodies.binding.value.ConverterValueModel;
import com.jgoodies.binding.value.ValueModel;

/**
 * I am a Factory that vends "converter" <code>ValueModel</code> instances.
 *
 * @see imcacat.epicsca4j.convert.ConverterFactory
 */
public class ConverterFactory extends
    imcacat.epicsca4j.convert.ConverterFactory {

  public static <E extends Enum<E>> ValueModel createEnumToColorConverter(
      ValueModel enumSubject, Map<E,Color>enumToColorMap) {
    return new ConverterValueModel(enumSubject,
      new EnumToColorConverter<E>(enumToColorMap));
  }

  public static <E extends Enum<E>> ValueModel createEnumToColorConverter(
      ValueModel enumSubject, Map<E,Color>enumToColorMap,
      Color defaultColor) {
    return new ConverterValueModel(enumSubject,
      new EnumToColorConverter<E>(enumToColorMap, defaultColor));
  }
}
