package imcacat.imcabc;

import imcacat.epicsca4j.model.EpicsEnum;

/**
 * I represent the move mode of an IMCA-CAT Energy pseudo motor.
 */
public enum EnergyMotorMoveMode implements EpicsEnum {
  FINE,
  COARSE,
  CUSTOM;

  public short asEpicsShort() {
    return (short)this.ordinal();
  }

  public EnergyMotorMoveMode fromEpicsShort(short epicsEnumValue) {
    for (EnergyMotorMoveMode each : EnergyMotorMoveMode.values())
      if (each.ordinal() == epicsEnumValue) return each;
    throw new IllegalArgumentException("Unexpected value: " + epicsEnumValue);
  }
}
