package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;
import imcacat.epicsca4j.model.EpicsPv;
import imcacat.epicsca4j.util.EpicsUtilities;

import com.jgoodies.binding.beans.Model;

/**
 * I reset an EPICS <code>sscan</code> record.
 */
public class EpicsScanResetter extends Model {
  private static final long serialVersionUID = 1;

  protected EpicsPv resetScanPv;

  public EpicsScanResetter(String resetScanPvName) {
    resetScanPv = new EpicsPv(
      resetScanPvName.endsWith(".PROC") ?
        resetScanPvName : resetScanPvName + ".PROC", false, false);
  }

  public void reset() throws InterruptedException, EpicsCaException {
    resetScanPv.setValueAndWait(EpicsUtilities.PROC_FIELD_PUT_VALUE);
  }

  public void release() {
    if (resetScanPv != null) resetScanPv.release();
  }
}
