package imcacat.imcabc;

import imcacat.epicsca4j.model.EpicsEnum;

/**
 * I model an experiment state status in J. Lewis Muir's Imcais software.
 */
public enum ExperimentStateStatus implements EpicsEnum {
  EXECUTING,
  DONE_OK,
  DONE_ERROR;

  public short asEpicsShort() {
    return (short)this.ordinal();
  }

  public ExperimentStateStatus fromEpicsShort(short epicsEnumValue) {
    for (ExperimentStateStatus each : ExperimentStateStatus.values())
      if (each.ordinal() == epicsEnumValue) return each;
    throw new IllegalArgumentException("Unexpected value: " + epicsEnumValue);
  }
}
