package imcacat.imcabc;

import java.io.File;
import java.io.FileFilter;

/**
 * I am a <code>FileFilter</code> that accepts <code>File</code> objects whose
 * names end with a specified "extension" string.
 */
public class ExtensionFileFilter implements FileFilter {
  protected String dotExtension;

  /**
   * Constructs an instance with the specified extension.
   * 
   * @param extension  match files ending in a dot ('.') followed by
   *                   <code>extension</code>; <code>extension</code> should
   *                   not contain a leading dot ('.')
   */
  public ExtensionFileFilter(String extension) {
    super();
    this.dotExtension = "." + extension;
  }

  public boolean accept(File aFile) {
    return aFile.getName().endsWith(dotExtension);
  }
}
