package imcacat.imcabc;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * I am a <code>javax.swing.filechooser.FileFilter</code> for use in a Swing
 * file chooser to filter selectable files. I accept all directories, but for
 * files I delegate whether a file is accepted to my
 * <code>java.io.FileFilter</code> instance.
 *
 * @see javax.swing.filechooser.FileFilter
 * @see java.io.FileFilter
 */
public class FileChooserFileFilter extends FileFilter {
  protected java.io.FileFilter fileFilter;
  protected String description;

  public FileChooserFileFilter(java.io.FileFilter fileFilter,
      String description) {
    super();
    this.fileFilter = fileFilter;
    this.description = description;
  }

  public boolean accept(File aFile) {
    if (aFile.isDirectory()) return true;
    return fileFilter.accept(aFile);
  }

  public String getDescription() {
    return description;
  }

}
