package imcacat.imcabc;

import java.awt.Frame;

/**
 * I am a view for controlling a {@link FilterRack} at the 17-BM beamline.
 */
public class FilterRackDialog17bm<T extends FilterRackPresentationModel<?>>
extends FilterRackDialog<T> {
  private static final long serialVersionUID = 1;

  protected static final int[] FILTER_THICKNESSES = new int[] {
    25, 50, 100, 200, 300, 400, 500, 1000
  };

  public FilterRackDialog17bm(Frame owner, String title, boolean modal,
      T model) {
    super(owner, title, modal, model);
  }

  @Override
  protected String[] getFilterDescriptions() {
    String[] descriptions = new String[FILTER_THICKNESSES.length];
    for (int i = 0; i < FILTER_THICKNESSES.length; i++)
      descriptions[i] = "(" + FILTER_THICKNESSES[i] + " \u03BCm" + ")";
    return descriptions;
  }
}
