package imcacat.imcabc;

import imcacat.epicsca4j.model.EpicsEnum;

/**
 * I represent {@link FilterRack} filter states.
 */
public enum FilterRackFilterState
implements EpicsEnum {
  RETRACTED,
  INSERTED,
  OPEN_CIRCUIT,
  SHORT_CIRCUIT,
  COMMUNICATION_ERROR;

  public short asEpicsShort() {
    return (short)this.ordinal();
  }

  public FilterRackFilterState fromEpicsShort(short epicsEnumValue) {
    for (FilterRackFilterState each : FilterRackFilterState.values())
      if (each.ordinal() == epicsEnumValue) return each;
    throw new IllegalArgumentException("Unexpected value: " + epicsEnumValue);
  }
}
