package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;
import gov.aps.jca.TimeoutException;

/**
 * I automatically optimize Horizontal Focus.
 */
public class HorizontalBeamFocusAutoOptimization17bm extends
    BeamFocusAutoOptimization17bm {
  @Override
  protected void initializeForVerticalOptimization() {}

  @Override
  protected void go()
  throws InterruptedException, TimeoutException, EpicsCaException {
    setStatus("Configuring beamline for Horizontal Focus optimization");
    disableAutobp();
    moveSlitsForHorizontalFocusOptimization();
    setProgress(10);

    setStatus("Scanning Horizontal Focus");
    scanHorizontalFocus();
    setProgress(80);

    setStatus("Moving Horizontal Focus to maximum");
    moveFocus(getXWithMaximumY(measuredXYSeries));
    setProgress(90);

    setStatus("Configuring beamline for use");
    moveMiddleAndDownstreamAndSmallSlitsToDefaultSize();
    enableAutobp();

    setProgressAndStatusToComplete();
  }
}
