package imcacat.imcabc;

import imcacat.epicsca4j.bean.OneWayPropertyChangeMediator;
import imcacat.epicsca4j.ca.EpicsCaException;
import imcacat.epicsca4j.model.EpicsPv;

/**
 * I am a model for details about a
 * <code>HorizontalBeamFocusAutoOptimization17bm</code>. I provide the
 * positions of the motors optimized by a
 * <code>HorizontalBeamFocusAutoOptimization17bm</code>.
 */
public class HorizontalBeamFocusAutoOptimizationDetails17bm
extends AutoOptimizationDetails {
  private static final long serialVersionUID = 1;

  public static final String PROPNAME_FOCUS_MOTOR_POSITION =
    "focusMotorPosition";

  protected EpicsPv focusMotorPositionPv;
  protected OneWayPropertyChangeMediator focusMotorPositionMediator;

  public HorizontalBeamFocusAutoOptimizationDetails17bm()
  throws InterruptedException, EpicsCaException {
    super();

    focusMotorPositionPv = new EpicsPv(
      Resources.getDefault().getFocusPositionPvName(), false, true);
    focusMotorPositionMediator = new OneWayPropertyChangeMediator(
      focusMotorPositionPv, this, EpicsPv.PROPNAME_VALUE,
      PROPNAME_FOCUS_MOTOR_POSITION);
  }

  @Override
  public void release() {
    focusMotorPositionMediator.release();
    focusMotorPositionPv.release();
    super.release();
  }

  public double getFocusMotorPosition()
  throws InterruptedException, EpicsCaException {
    return (Double)focusMotorPositionPv.getValue();
  }
}
