package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;

import org.junit.Test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

/**
 * I test {@link MadFluorescenceScan17bm}.
 */
public class MadFluorescenceScan17bmTest {
  @Test
  public void setElement01()
  throws InterruptedException, EpicsCaException {
    MadFluorescenceScan elementEdge = new MadFluorescenceScan17bm();
    elementEdge.setElement(MadElement.CO);
    assertTrue(MadElement.CO.getEdges().contains(elementEdge.getEdge()));
  }

  @Test
  public void setEdge01()
  throws InterruptedException, EpicsCaException {
    MadFluorescenceScan elementEdge = new MadFluorescenceScan17bm();
    elementEdge.setElement(MadElement.DY);
    elementEdge.setEdge(MadEdge.DY_L3);
    assertEquals(MadEdge.DY_L3, elementEdge.getEdge());
  }

  @Test(expected=IllegalArgumentException.class)
  public void setEdge02()
  throws InterruptedException, EpicsCaException {
    MadFluorescenceScan elementEdge = new MadFluorescenceScan17bm();
    elementEdge.setElement(MadElement.DY);
    elementEdge.setEdge(MadEdge.CO_K);
  }
}
