package imcacat.imcabc;

import imcacat.epicsca4j.util.UiUtilities;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JPanel;

import org.jfree.chart.ChartPanel;

/**
 * I am a view of a {@link FluorescenceScan} displaying a plot of energy vs.
 * fluorescence as reported by the <code>FluorescenceScan</code>.
 */
public class MadFluorescenceScanChartPanel extends JPanel {
  private static final long serialVersionUID = 1;

  protected static final Dimension PREFERRED_SIZE = new Dimension(200, 300);

  protected MadFluorescenceScanChartPresentationModel model;

  public MadFluorescenceScanChartPanel(
      MadFluorescenceScanChartPresentationModel model) {
    super();
    this.model = model;
    setLayout(new BorderLayout());
    add(buildMainPanel(), BorderLayout.CENTER);
    setPreferredSize(UiUtilities.createScaledDownToFitIn(getPreferredSize(),
      PREFERRED_SIZE));
  }

  protected JPanel buildMainPanel() {
    ChartPanel panel = new ChartPanel(model.getChart());
    panel.setDomainZoomable(false);
    panel.setRangeZoomable(false);
    return panel;
  }
}
