package imcacat.imcabc;

import java.util.ArrayList;
import java.util.List;

/**
 * I model fluorescence scan data.
 *
 * @see MadFluorescenceScan
 */
public class MadFluorescenceScanData {
  protected MadEdge edge;
  protected List<Double> energy = new ArrayList<Double>();
  protected List<Long> intensity = new ArrayList<Long>();
  protected List<Long> fluorescence = new ArrayList<Long>();

  /**
   * @param energy energy data in eV
   */
  public MadFluorescenceScanData(MadEdge edge, List<Double> energy,
      List<Long> intensity, List<Long> fluorescence) {
    super();
    this.edge = edge;
    this.energy = energy;
    this.intensity = intensity;
    this.fluorescence = fluorescence;
  }

  public MadEdge getEdge() {
    return edge;
  }

  public void setEdge(MadEdge edge) {
    this.edge = edge;
  }

  /**
   * @return energy data in eV
   */
  public List<Double> getEnergy() {
    return energy;
  }

  /**
   * @param energy energy data in eV
   */
  public void setEnergy(List<Double> energy) {
    this.energy = energy;
  }

  public List<Long> getIntensity() {
    return intensity;
  }

  public void setIntensity(List<Long> intensity) {
    this.intensity = intensity;
  }

  public List<Long> getFluorescence() {
    return fluorescence;
  }

  public void setFluorescence(List<Long> fluorescence) {
    this.fluorescence = fluorescence;
  }
}
