package imcacat.imcabc;

import java.io.File;
import java.util.Comparator;
import java.util.List;

/**
 * I am a <code>Comparator</code> for comparing MAD fluorescence scan data
 * files.
 *
 * @see MadFluorescenceScanDataFileFilter
 */
public class MadFluorescenceScanDataFileComparator
implements Comparator<File> {
  public int compare(File object1, File object2) {
    List<Object> parts1 = MadFluorescenceScanDataFileFilter.parseFileName(
      (object1).getName());
    List<Object> parts2 = MadFluorescenceScanDataFileFilter.parseFileName(
      (object2).getName());
    if (parts1 == null && parts2 == null) return 0;
    if (parts1 == null) return -1;
    if (parts2 == null) return 1;
    MadEdge edge1 = (MadEdge)parts1.get(0);
    MadEdge edge2 = (MadEdge)parts2.get(0);
    if (!edge1.equals(edge2)) return edge1.compareTo(edge2);
    return ((Integer)parts1.get(1)).compareTo((Integer)parts2.get(1));
  }
}
