package imcacat.imcabc;

import imcacat.epicsca4j.model.EpicsEnum;

/**
 * I represent the desired mini-beam apparatus aperture selection.
 */
public enum MinibeamAperture implements EpicsEnum {
  NONE,
  ONE,
  TWO,
  THREE,
  FOUR;

  public short asEpicsShort() {
    return (short)this.ordinal();
  }

  public MinibeamAperture fromEpicsShort(short epicsEnumValue) {
    for (MinibeamAperture each : MinibeamAperture.values())
      if (each.ordinal() == epicsEnumValue) return each;
    throw new IllegalArgumentException("Unexpected value: " + epicsEnumValue);
  }
}
