package imcacat.imcabc;

import imcacat.epicsca4j.model.EpicsEnum;

/**
 * I represent the read-back value of a mini-beam apparatus aperture
 * selection.
 */
public enum MinibeamApertureRbv implements EpicsEnum {
  NONE,
  ONE,
  TWO,
  THREE,
  FOUR,
  MOVING,
  SCANNING,
  UNKNOWN;

  public short asEpicsShort() {
    return (short)this.ordinal();
  }

  public MinibeamApertureRbv fromEpicsShort(short epicsEnumValue) {
    for (MinibeamApertureRbv each : MinibeamApertureRbv.values())
      if (each.ordinal() == epicsEnumValue) return each;
    throw new IllegalArgumentException("Unexpected value: " + epicsEnumValue);
  }
}
