package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;
import imcacat.epicsca4j.model.EpicsScan;
import imcacat.epicsca4j.model.EpicsScanFactory;

/**
 * I am an <code>Optimization</code> for the 17-ID beamline.
 */
public abstract class Optimization17id extends Optimization {
  protected EpicsScan getScanInstance()
  throws InterruptedException, EpicsCaException {
    return EpicsScanFactory.getScanInstance(
      Resources.getDefault().getAScan1PvName());
  }

  protected EpicsScanResetter getScanResetterInstance() {
    return new EpicsScanResetter(
      Resources.getDefault().getAScan1ResetPvName());
  }
}
