package imcacat.imcabc;

/**
 * I call my presentation model's
 * <code>updatePointOfInterest(Double, Double)</code> method with the new
 * crosshair position whenever it changes.
 */
public class OptimizationCrosshairListener extends CrosshairListener {
  protected OptimizationPresentationModel presentationModel;

  public OptimizationCrosshairListener(
      OptimizationPresentationModel presentationModel) {
    super();
    this.presentationModel = presentationModel;
  }

  @Override
  void crosshairChanged(Double domainValue, Double rangeValue) {
    presentationModel.updatePointOfInterest(domainValue, rangeValue);
  }
}
