package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;

import org.jfree.data.xy.XYSeries;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

/**
 * I test {@link Optimization}.
 */
public class OptimizationTest {
  @Test
  public void testGetXWithMaximumY01() throws EpicsCaException {
    Optimization optimization = new NullOptimization();
    XYSeries data = createXYSeries(new double[][] {
      {  0.0,   1.0,   2.0,   3.0,   4.0,   5.0,   6.0,  7.0 },
      { 50.0, 100.0, 150.0, 200.0, 600.0, 220.0, 100.0, 40.0 }
    });
    assertEquals(4.0, optimization.getXWithMaximumY(data), 0.0001);
  }

  @Test
  public void testGetXWithMaximumY02() throws EpicsCaException {
    Optimization optimization = new NullOptimization();
    XYSeries data = createXYSeries(new double[][] {
      {   0.0,   1.0,   2.0,   3.0,   4.0,   5.0,   6.0,  7.0 },
      { 700.0, 100.0, 150.0, 200.0, 600.0, 220.0, 100.0, 40.0 }
    });
    assertEquals(0.0, optimization.getXWithMaximumY(data), 0.0001);
  }

  @Test(expected=IndexOutOfBoundsException.class)
  public void testGetXWithMaximumY03() throws EpicsCaException {
    Optimization optimization = new NullOptimization();
    XYSeries data = createXYSeries(new double[][] {{}, {}});
    optimization.getXWithMaximumY(data);
  }

  protected XYSeries createXYSeries(double[][] data) {
    XYSeries series = new XYSeries("test series");
    for (int i = 0; i < data[0].length; i++)
      series.add(data[0][i], data[1][i]);
    return series;
  }
}
