package imcacat.imcabc;

import imcacat.epicsca4j.bean.OneWayPropertyChangeMediator;
import imcacat.epicsca4j.ca.EpicsCaException;
import imcacat.epicsca4j.model.EpicsPv;

/**
 * I am an <code>OptimizeFacade</code> for the 17-BM beamline.
 */
public class OptimizeFacade17bm extends OptimizeFacade {
  private static final long serialVersionUID = 1;

  public static final String PROPNAME_OMEGA_POSITION = "omegaPosition";

  protected EpicsPv omegaPositionPv;
  protected OneWayPropertyChangeMediator omegaMediator;

  public OptimizeFacade17bm() throws InterruptedException, EpicsCaException {
    super();
  }

  protected void initializeManualSection()
  throws InterruptedException, EpicsCaException {
    omegaPositionPv = new EpicsPv(
      Resources.getDefault().getOmegaPositionPvName(), false, true);
    omegaMediator = new OneWayPropertyChangeMediator(omegaPositionPv, this,
      EpicsPv.PROPNAME_VALUE, PROPNAME_OMEGA_POSITION);
  }

  public double getOmegaPosition()
  throws InterruptedException, EpicsCaException {
    return (Double)omegaPositionPv.getValue();
  }
}
