package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;

import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

/**
 * I am the Optimize tab view.
 */
public abstract class OptimizePanel<M extends OptimizePresentationModel<?
    extends OptimizeFacade>> extends JPanel {
  private static final long serialVersionUID = 1;

  protected M model;

  public OptimizePanel(M model)
  throws EpicsCaException {
    super();
    this.model = model;
    setLayout(new BorderLayout());
    add(buildMainPanel(), BorderLayout.CENTER);
  }

  protected JComponent buildMainPanel() throws EpicsCaException {
    FormLayout layout = new FormLayout(
      "pref, pref, fill:pref:grow",
      "fill:pref:grow");
    JPanel panel = new JPanel(layout);
    CellConstraints cc = new CellConstraints();
    panel.add(buildLeftPanel(), cc.xy(1, 1));
    panel.add(buildLeftRightSeparator(), cc.xy(2,1));
    panel.add(buildRightPanel(), cc.xy(3, 1));
    return panel;
  }

  protected abstract JComponent buildLeftPanel();

  protected JComponent buildRightPanel() throws EpicsCaException {
    return new OptimizationPanel(new OptimizationPresentationModel(
      model.getOptimizationBeanChannel()));
  }

  protected JComponent buildLeftRightSeparator() {
    JPanel panel = new JPanel(new BorderLayout());
    panel.add(new JSeparator(SwingConstants.VERTICAL), BorderLayout.CENTER);
    panel.setBorder(new EmptyBorder(10, 0, 10, 0));
    return panel;
  }
}
