package imcacat.imcabc;

import javax.swing.Action;

import imcacat.epicsca4j.ca.EpicsCaException;

import com.jgoodies.binding.value.ValueHolder;
import com.jgoodies.binding.value.ValueModel;

/**
 * I am an <code>OptimizePresentationModel</code> for the 17-ID beamline.
 */
public class OptimizePresentationModel17id extends
    OptimizePresentationModel<OptimizeFacade17id> {
  private static final long serialVersionUID = 1;

  protected OptimizeAction manualOptimizeSecondCrystalPitchAction;
  protected OptimizeAction manualOptimizeSecondCrystalRollAction;

  public OptimizePresentationModel17id()
  throws InterruptedException, EpicsCaException {
    this(new OptimizeFacade17id(), new ValueHolder(new NullOptimization(),
      true), new ImcabcPresentationModel17id());
  }

  public OptimizePresentationModel17id(OptimizeFacade17id bean,
      ValueModel optimizationBeanChannel,
      ImcabcPresentationModel imcabcPresentationModel)
  throws EpicsCaException {
    this(new ValueHolder(bean, true), optimizationBeanChannel,
      imcabcPresentationModel);
  }


  public OptimizePresentationModel17id(ValueModel beanChannel,
      ValueModel optimizationBeanChannel)
  throws InterruptedException, EpicsCaException {
    this(beanChannel, optimizationBeanChannel,
      new ImcabcPresentationModel17id());
  }

  public OptimizePresentationModel17id(ValueModel beanChannel,
      ValueModel optimizationBeanChannel,
      ImcabcPresentationModel imcabcPresentationModel)
  throws EpicsCaException {
    super(beanChannel, optimizationBeanChannel, imcabcPresentationModel);

    manualOptimizeSecondCrystalPitchAction =
      new OptimizeAction(SecondCrystalPitchManualOptimization17id.class,
        optimizationBeanChannel);
    optimizeActions.add(manualOptimizeSecondCrystalPitchAction);

    manualOptimizeSecondCrystalRollAction =
      new OptimizeAction(SecondCrystalRollManualOptimization17id.class,
        optimizationBeanChannel);
    optimizeActions.add(manualOptimizeSecondCrystalRollAction);
  }

  public Action getOptimizeSecondCrystalPitchAction() {
    return manualOptimizeSecondCrystalPitchAction;
  }

  public Action getOptimizeSecondCrystalRollAction() {
    return manualOptimizeSecondCrystalRollAction;
  }
}
