package imcacat.imcabc;

import imcacat.epicsca4j.ca.EpicsCaException;
import gov.aps.jca.TimeoutException;

/**
 * I automatically optimize Vertical Focus.
 */
public class VerticalBeamFocusAutoOptimization17bm extends
    BeamFocusAutoOptimization17bm {
  @Override
  protected void initializeForHorizontalOptimization() {}

  @Override
  protected void go()
  throws InterruptedException, TimeoutException, EpicsCaException {
    setStatus("Configuring beamline for Vertical Focus optimization");
    disableAutobp();
    moveSlitsForVerticalFocusOptimization();
    setProgress(10);

    setStatus("Scanning Vertical Focus");
    scanVerticalFocus();
    setProgress(80);

    setStatus("Moving Vertical Focus to maximum");
    moveMirrorBend(getXWithMaximumY(measuredXYSeries));
    setProgress(90);

    setStatus("Configuring beamline for use");
    moveMiddleAndDownstreamAndSmallSlitsToDefaultSize();
    enableAutobp();

    setProgressAndStatusToComplete();
  }
}
