package imcacat.imcabc;

import imcacat.epicsca4j.bean.OneWayPropertyChangeMediator;
import imcacat.epicsca4j.ca.EpicsCaException;
import imcacat.epicsca4j.model.EpicsPv;

/**
 * I am a model for details about a
 * {@link VerticalBeamFocusAutoOptimization17bm}. I provide the positions of
 * the motors optimized by a
 * <code>VerticalBeamFocusAutoOptimization17bm</code>.
 */
public class VerticalBeamFocusAutoOptimizationDetails17bm
extends AutoOptimizationDetails {
  private static final long serialVersionUID = 1;

  public static final String PROPNAME_MIRROR_BEND_MOTOR_POSITION =
    "mirrorBendMotorPosition";

  protected EpicsPv mirrorBendMotorPositionPv;
  protected OneWayPropertyChangeMediator mirrorBendMotorPositionMediator;

  public VerticalBeamFocusAutoOptimizationDetails17bm()
  throws InterruptedException, EpicsCaException {
    super();

    mirrorBendMotorPositionPv = new EpicsPv(
      Resources.getDefault().getMirrorBendPositionPvName(), false, true);
    mirrorBendMotorPositionMediator = new OneWayPropertyChangeMediator(
      mirrorBendMotorPositionPv, this, EpicsPv.PROPNAME_VALUE,
      PROPNAME_MIRROR_BEND_MOTOR_POSITION);
  }

  @Override
  public void release() {
    mirrorBendMotorPositionMediator.release();
    mirrorBendMotorPositionPv.release();
    super.release();
  }

  public double getMirrorBendMotorPosition()
  throws InterruptedException, EpicsCaException {
    return (Double)mirrorBendMotorPositionPv.getValue();
  }
}
