package imcacat.imcabc;

/**
 * I sample an {@link XYFunction} over a specified range, a specified number
 * of times.
 * <p>
 * I am useful when there is a need to have discrete data points from a
 * function.
 */
public class XYFunctionSampler {
  protected XYFunction function;
  protected double xStart;
  protected double xStep;
  protected int numberOfSamples;

  public XYFunctionSampler(XYFunction function, double xStart, double xEnd,
      int numberOfSamples) {
    super();
    this.function = function;
    this.xStart = xStart;
    this.numberOfSamples = numberOfSamples;
    xStep = (xEnd - xStart) / (double)numberOfSamples;
  }

  public double getX(int index) {
    return xStart + ((double)index * xStep);
  }

  public double getY(int index) {
    return function.getY(getX(index));
  }

  public int getNumberOfSamples() {
    return numberOfSamples;
  }
}
