package imcacat.imcabc;

import java.util.Iterator;
import java.util.List;

import org.apache.log4j.Logger;
import org.jfree.data.general.SeriesException;
import org.jfree.data.xy.XYSeries;

/**
 * I set the specified data in the specified <code>XYSeries</code> when I am
 * run.
 */
public class XYSeriesDataSetter implements Runnable {
  private static final Logger LOG = Logger.getLogger(
    XYSeriesDataSetter.class);

  protected XYSeries series;
  protected List<? extends Number> xData;
  protected List<? extends Number> yData;

  public XYSeriesDataSetter(XYSeries series, List<? extends Number> xData,
      List<? extends Number> yData) {
    super();
    this.series = series;
    this.xData = xData;
    this.yData = yData;
  }

  public void run() {
    series.clear();
    Iterator<? extends Number> iX = xData.iterator();
    Iterator<? extends Number> iY = yData.iterator();
    while (iX.hasNext() && iY.hasNext()) {
      try {
        series.add(iX.next(), iY.next(), false);
      } catch (SeriesException e) {
        LOG.error("Duplicate data point X value");
      }
    }
    series.fireSeriesChanged();
  }
}
