package imcacat.imcabc.util;

import java.util.Collection;
import java.util.List;
import java.util.ListIterator;

/**
 * I provide utility methods related to {@link Collection} objects.
 */
public class CollectionUtilities {
  private CollectionUtilities() {}

  public static double[] toPrimitiveDoubleArray(List<Double> values) {
    double primitiveValues[] = new double[values.size()];
    for (ListIterator<Double> i = values.listIterator(); i.hasNext();) {
      Double value = i.next();
      primitiveValues[i.previousIndex()] = value;
    }
    return primitiveValues;
  }

  public static float[] toPrimitiveFloatArray(List<Float> values) {
    float primitiveValues[] = new float[values.size()];
    for (ListIterator<Float> i = values.listIterator(); i.hasNext();) {
      Float value = i.next();
      primitiveValues[i.previousIndex()] = value;
    }
    return primitiveValues;
  }
}
