package imcacat.imcabc.util;

import org.junit.Test;
import static org.junit.Assert.assertEquals;

/**
 * I test {@link FileUtilities}.
 */
public class FileUtilitiesTest {
  @Test
  public void testCreateFileNameWithExtension01() {
    // no existing extension
    String expected = "resume.pdf";
    String actual = FileUtilities.createFileNameWithExtension("resume",
      "pdf");
    assertEquals(expected, actual);
  }

  @Test
  public void testCreateFileNameWithExtension02() {
    // existing two character extension
    String expected = "resume.pdf";
    String actual = FileUtilities.createFileNameWithExtension("resume.ps",
      "pdf");
    assertEquals(expected, actual);
  }

  @Test
  public void testCreateFileNameWithExtension03() {
    // existing three character extension
    String expected = "resume.pdf";
    String actual = FileUtilities.createFileNameWithExtension("resume.txt",
      "pdf");
    assertEquals(expected, actual);
  }

  @Test
  public void testCreateFileNameWithExtension04() {
    // existing four character extension
    String expected = "resume.pdf";
    String actual = FileUtilities.createFileNameWithExtension("resume.html",
      "pdf");
    assertEquals(expected, actual);
  }

  @Test
  public void testCreateFileNameWithExtension05() {
    // existing extension greater than four characters
    String expected = "build.properties.tmp";
    String actual = FileUtilities.createFileNameWithExtension(
      "build.properties", "tmp");
    assertEquals(expected, actual);
  }

  @Test
  public void testCreateFileNameWithExtension06() {
    // existing zero length extension
    String expected = "resume.pdf";
    String actual = FileUtilities.createFileNameWithExtension("resume.",
      "pdf");
    assertEquals(expected, actual);
  }
}
